DAT programName         byte "fourMotorsOneCog121216c", 0
CON
{{
  Based on code by Hanno.
  
}}
{
  121215a Begin converting Hano's two motor driver into a four
  motor driver.
  15a Mostly just change formatting.
  15b Remove encoder code.
  15e Change masks to arrays.
  15l Seems to work.
  15m Remove debug code.
  
}
{*******************************************************
* (C) 2010 HannoWare.com                               *
* Drive 2 motors with h-bridge and read encoder        *
* AppletImage=motor.gif                                *
********************************************************}
CON
 
  MAXSPEED = 4000
  PARENT_MAXSPEED = 1000
  SPEED_MULTIPLIER = MAXSPEED / PARENT_MAXSPEED
  MIN_PASM_WAIT = 40 '5
  
  motorUpdateHz = 200
  'pins for h-bridge: 3,4,26,27
  'pins for encoder: 12,13
  {forwardMask[0] = |< 3  ' change to match forward pin on H-bridge
  forwardMask[1] = |< 26 ' change to match forward pin on H-bridge
  backwardMask[0] = |< 5  ' change to match backward pin on H-bridge
  backwardMask[1] = |< 25 ' change to match backward pin on H-bridge
  'm1Dir= |< 3
  enableMask[0]= |<4
  'm2Dir= |<26
  enableMask[1]= |<27
  }
VAR

  long cog
  long motorControlArray[10]  'structure populated by spin code to set motor direction
  long forwardMask[4]
  long backwardMask[4]
  long enableMask[4]
  long speed[4]
  
OBJ

  Pst : "Parallax Serial Terminal"

PUB Start(forwardPin0, forwardPin1, forwardPin2, forwardPin3, {
             } backwardPin0, backwardPin1, backwardPin2, backwardPin3, {
             } enablePin0, enablePin1, enablePin2, enablePin3)
'starts 1 encoder cog and 1 motor cog.  initializes positions
  Pst.Start(115200)
  forwardMask[0] := |< forwardPin0
  forwardMask[1] := |< forwardPin1
  forwardMask[2] := |< forwardPin2
  forwardMask[3] := |< forwardPin3
  backwardMask[0] := |< backwardPin0
  backwardMask[1] := |< backwardPin1
  backwardMask[2] := |< backwardPin2
  backwardMask[3] := |< backwardPin3
  enableMask[0] := |< enablePin0
  enableMask[1] := |< enablePin1
  enableMask[2] := |< enablePin2
  enableMask[3] := |< enablePin3

  Stop
  
  SetupMotor  
  
PUB Stop
'' Stop driver and release cog

  if cog
    cogstop(cog~ - 1)
 
PUB Update(speed0, speed1, speed2, speed3)| activeMask, speedIndex[4], startIndex, speedIndexIndex, previouslyUsedIndex, arrayIndex
'updates motor control with desired speed
 
  ' combined PWM pin mask
  activeMask := 0
  if speed0 > 0
    activeMask += forwardMask[0]                ' if #1 positive speed add direction pin to mask
  else
    activeMask += backwardMask[0]
  if speed1 > 0
    activeMask += forwardMask[1]                ' if #2 positive speed add direction pin to mask
  else
    activeMask += backwardMask[1]
  if speed2 > 0
    activeMask += forwardMask[2]                ' if #1 positive speed add direction pin to mask
  else
    activeMask += backwardMask[2]
  if speed3 > 0
    activeMask += forwardMask[3]                ' if #2 positive speed add direction pin to mask
  else
    activeMask += backwardMask[3]
    
  Pst.char(13)
  Pst.str(string(13, "speed0 = "))
  Pst.dec(speed0)
  Pst.str(string(13, "speed1 = ")) 
  Pst.dec(speed1)
  Pst.str(string(13, "speed2 = ")) 
  Pst.dec(speed2)
  Pst.str(string(13, "speed3 = ")) 
  Pst.dec(speed3)
                              
  speed[0] := (||speed0 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[1] := (||speed1 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[2] := (||speed2 * SPEED_MULTIPLIER) <# MAXSPEED
  speed[3] := (||speed3 * SPEED_MULTIPLIER) <# MAXSPEED
  repeat result from 0 to 3
    if speed[result]
      activeMask |= enableMask[result]
  
  Pst.char(13)
  repeat result from 0 to 3
    Pst.str(string(13, "Speed["))
    Pst.dec(result)
    Pst.str(string("] = ")) 
    Pst.dec(speed[result])

  speedIndex[0] := 0
  repeat result from 1 to 3
    if speed[result] > speed[speedIndex[0]]
      speedIndex[0] := result
  'result := 0
  Pst.str(string(13, "speedIndex["))
  Pst.dec(0)
  Pst.str(string("] = ")) 
  Pst.dec(speedIndex[0]) 
  repeat result from 1 to 3
    if result <> speedIndex[0]
      startIndex := result
      quit 
  speedIndex[1] := startIndex 'result
  repeat result from startIndex to 3
    if result <> speedIndex[0]
      if speed[result] > speed[speedIndex[1]]
        speedIndex[1] := result
  Pst.str(string(13, "speedIndex["))
  Pst.dec(1)
  Pst.str(string("] = ")) 
  Pst.dec(speedIndex[1])   
        
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      startIndex := result
      quit 
  speedIndex[2] := startIndex
  repeat result from startIndex to 3
    if result <> speedIndex[0] and result <> speedIndex[1]
      if speed[result] > speed[speedIndex[2]]
        speedIndex[2] := result
  Pst.str(string(13, "speedIndex["))
  Pst.dec(2)
  Pst.str(string("] = ")) 
  Pst.dec(speedIndex[2]) 
  
  repeat result from 0 to 3
    if result <> speedIndex[0] and result <> speedIndex[1] and result <> speedIndex[2]
      startIndex := result
      quit 
  speedIndex[3] := startIndex
  Pst.str(string(13, "speedIndex["))
  Pst.dec(3)
  Pst.str(string("] = ")) 
  Pst.dec(speedIndex[3])   
  
  'repeat result from 0 to 3

  motorControlArray[0] := activeMask ' set both motors on mask to where the PASM portion
                                     ' can read it
  motorControlArray[1] := speed[speedIndex[3]] + MIN_PASM_WAIT ' time slowest motor is on
  Pst.str(string(13, "                        33222222222211111111110000000000"))
  Pst.str(string(13, "                        10987654321098765432109876543210"))
  Pst.str(string(13, "motorControlArray["))
  Pst.dec(0)
  Pst.str(string("] = %")) 
  Pst.bin(motorControlArray[0], 32)
  Pst.str(string(13, "motorControlArray["))
  Pst.dec(1)
  Pst.str(string("] = ")) 
  Pst.dec(motorControlArray[1]) 
  arrayIndex := 2
  repeat result from 3 to 1
    activeMask &= !enableMask[speedIndex[result]]
    motorControlArray[arrayIndex++] := activeMask
    motorControlArray[arrayIndex++] := (speed[speedIndex[result - 1]] - speed[speedIndex[result]]) + MIN_PASM_WAIT ' time slowest motor is on
    Pst.str(string(13, "                        33222222222211111111110000000000"))
    Pst.str(string(13, "                        10987654321098765432109876543210"))
    Pst.str(string(13, "motorControlArray["))
    Pst.dec(arrayIndex - 2)
    Pst.str(string("] = %")) 
    Pst.bin(motorControlArray[arrayIndex - 2], 32)
    Pst.str(string(13, "motorControlArray["))
    Pst.dec(arrayIndex - 1)
    Pst.str(string("] = ")) 
    Pst.dec(motorControlArray[arrayIndex - 1])
  
  {   
  activeMask -= enableMask[speedIndex[3]] ' mask to turn off slowest motor
  motorControlArray[2] := activeMask
  motorControlArray[3] := (speed[speedIndex[2]] - speed[speedIndex[3]]) + MIN_PASM_WAIT ' time slowest motor is on

  activeMask -= enableMask[speedIndex[2]]
  motorControlArray[4] := activeMask
  motorControlArray[5] := (speed[speedIndex[1]] - speed[speedIndex[2]]) + MIN_PASM_WAIT 

  activeMask -= enableMask[speedIndex[1]]
  motorControlArray[6] := activeMask
  motorControlArray[7] := (speed[speedIndex[0]] - speed[speedIndex[1]]) + MIN_PASM_WAIT 
  }
  activeMask &= !enableMask[speedIndex[0]]
  motorControlArray[8] := activeMask
  motorControlArray[9] := (MAXSPEED - speed[speedIndex[0]]) + MIN_PASM_WAIT ' time all motors off
  Pst.str(string(13, "                        33222222222211111111110000000000"))
  Pst.str(string(13, "                        10987654321098765432109876543210"))
  Pst.str(string(13, "motorControlArray["))
  Pst.dec(8)
  Pst.str(string("] = %")) 
  Pst.bin(motorControlArray[8], 32)
  Pst.str(string(13, "motorControlArray["))
  Pst.dec(9)
  Pst.str(string("] = ")) 
  Pst.dec(motorControlArray[9]) 
  Pst.CharIn 
  
PUB SetupMotor

  motorControlArray[1] := MIN_PASM_WAIT
  motorControlArray[3] := MIN_PASM_WAIT
  motorControlArray[5] := MIN_PASM_WAIT
  motorControlArray[7] := MIN_PASM_WAIT
  motorControlArray[9] := MIN_PASM_WAIT
  diraV := forwardMask[0] | forwardMask[1] | forwardMask[2] | forwardMask[3] | {
  } backwardMask[0] | backwardMask[1] | backwardMask[2] | backwardMask[3] | {
  } enableMask[0] | enableMask[1] | enableMask[2] | enableMask[3]
  andV := !diraV
  cognew(@doPWM, @motorControlArray)

PUB GetFileName

  result := @programName
  
DAT

' outputs pwm to motors
' uses pwm structure to get bit values and duty cycles
                        org
doPWM                   or      dira,dirav
 loop                   mov     ptr,par
                        mov     :i,#5
:duty                   rdlong  orV,ptr 'get value to or
                        add     ptr,#4
                        mov     :t,outa
                        rdlong  timeV, ptr 'get wait
                        add     ptr, #4
                        and     :t, andV
                        or      :t, orV
                        mov     outa, :t
                        add     timeV, cnt
                        waitcnt timeV, #0
                        djnz    :i, #:duty
                        jmp     #loop
:t                      long 1
:i                      long 1
diraV                   long 1
andV                    long 1    
ptr                     long 1
orV                     long 1
timeV                   long 1